Create completion
completions.create(CompletionCreateParams**kwargs) -> Completion
post /completions
Creates a completion for the provided prompt and parameters.
Returns a completion object, or a sequence of completion objects if the request is streamed.
Parameters
-
model: Union[str, Literal["gpt-3.5-turbo-instruct", "davinci-002", "babbage-002"]]ID of the model to use. You can use the List models API to see all of your available models, or see our Model overview for descriptions of them.
-
str -
Literal["gpt-3.5-turbo-instruct", "davinci-002", "babbage-002"]ID of the model to use. You can use the List models API to see all of your available models, or see our Model overview for descriptions of them.
-
"gpt-3.5-turbo-instruct" -
"davinci-002" -
"babbage-002"
-
-
-
prompt: Union[str, Sequence[str], Iterable[int], 2 more]The prompt(s) to generate completions for, encoded as a string, array of strings, array of tokens, or array of token arrays.
Note that <|endoftext|> is the document separator that the model sees during training, so if a prompt is not specified the model will generate as if from the beginning of a new document.
-
str -
Sequence[str] -
Iterable[int] -
Iterable[Iterable[int]]
-
-
best_of: Optional[int]Generates
best_ofcompletions server-side and returns the "best" (the one with the highest log probability per token). Results cannot be streamed.When used with
n,best_ofcontrols the number of candidate completions andnspecifies how many to return –best_ofmust be greater thann.Note: Because this parameter generates many completions, it can quickly consume your token quota. Use carefully and ensure that you have reasonable settings for
max_tokensandstop. -
echo: Optional[bool]Echo back the prompt in addition to the completion
-
frequency_penalty: Optional[float]Number between -2.0 and 2.0. Positive values penalize new tokens based on their existing frequency in the text so far, decreasing the model's likelihood to repeat the same line verbatim.
See more information about frequency and presence penalties.
-
logit_bias: Optional[Dict[str, int]]Modify the likelihood of specified tokens appearing in the completion.
Accepts a JSON object that maps tokens (specified by their token ID in the GPT tokenizer) to an associated bias value from -100 to 100. You can use this tokenizer tool to convert text to token IDs. Mathematically, the bias is added to the logits generated by the model prior to sampling. The exact effect will vary per model, but values between -1 and 1 should decrease or increase likelihood of selection; values like -100 or 100 should result in a ban or exclusive selection of the relevant token.
As an example, you can pass
{"50256": -100}to prevent the <|endoftext|> token from being generated. -
logprobs: Optional[int]Include the log probabilities on the
logprobsmost likely output tokens, as well the chosen tokens. For example, iflogprobsis 5, the API will return a list of the 5 most likely tokens. The API will always return thelogprobof the sampled token, so there may be up tologprobs+1elements in the response.The maximum value for
logprobsis 5. -
max_tokens: Optional[int]The maximum number of tokens that can be generated in the completion.
The token count of your prompt plus
max_tokenscannot exceed the model's context length. Example Python code for counting tokens. -
n: Optional[int]How many completions to generate for each prompt.
Note: Because this parameter generates many completions, it can quickly consume your token quota. Use carefully and ensure that you have reasonable settings for
max_tokensandstop. -
presence_penalty: Optional[float]Number between -2.0 and 2.0. Positive values penalize new tokens based on whether they appear in the text so far, increasing the model's likelihood to talk about new topics.
See more information about frequency and presence penalties.
-
seed: Optional[int]If specified, our system will make a best effort to sample deterministically, such that repeated requests with the same
seedand parameters should return the same result.Determinism is not guaranteed, and you should refer to the
system_fingerprintresponse parameter to monitor changes in the backend. -
stop: Optional[Union[Optional[str], Sequence[str], null]]Not supported with latest reasoning models
o3ando4-mini.Up to 4 sequences where the API will stop generating further tokens. The returned text will not contain the stop sequence.
-
Optional[str] -
Sequence[str]
-
-
stream: Optional[Literal[false]]Whether to stream back partial progress. If set, tokens will be sent as data-only server-sent events as they become available, with the stream terminated by a
data: [DONE]message. Example Python code.false
-
stream_options: Optional[ChatCompletionStreamOptionsParam]Options for streaming response. Only set this when you set
stream: true.-
include_obfuscation: Optional[bool]When true, stream obfuscation will be enabled. Stream obfuscation adds random characters to an
obfuscationfield on streaming delta events to normalize payload sizes as a mitigation to certain side-channel attacks. These obfuscation fields are included by default, but add a small amount of overhead to the data stream. You can setinclude_obfuscationto false to optimize for bandwidth if you trust the network links between your application and the OpenAI API. -
include_usage: Optional[bool]If set, an additional chunk will be streamed before the
data: [DONE]message. Theusagefield on this chunk shows the token usage statistics for the entire request, and thechoicesfield will always be an empty array.All other chunks will also include a
usagefield, but with a null value. NOTE: If the stream is interrupted, you may not receive the final usage chunk which contains the total token usage for the request.
-
-
suffix: Optional[str]The suffix that comes after a completion of inserted text.
This parameter is only supported for
gpt-3.5-turbo-instruct. -
temperature: Optional[float]What sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic.
We generally recommend altering this or
top_pbut not both. -
top_p: Optional[float]An alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered.
We generally recommend altering this or
temperaturebut not both. -
user: Optional[str]A unique identifier representing your end-user, which can help OpenAI to monitor and detect abuse. Learn more.
Returns
-
class Completion: …Represents a completion response from the API. Note: both the streamed and non-streamed response objects share the same shape (unlike the chat endpoint).
-
id: strA unique identifier for the completion.
-
choices: List[CompletionChoice]The list of completion choices the model generated for the input prompt.
-
finish_reason: Literal["stop", "length", "content_filter"]The reason the model stopped generating tokens. This will be
stopif the model hit a natural stop point or a provided stop sequence,lengthif the maximum number of tokens specified in the request was reached, orcontent_filterif content was omitted due to a flag from our content filters.-
"stop" -
"length" -
"content_filter"
-
-
index: int -
logprobs: Optional[Logprobs]-
text_offset: Optional[List[int]] -
token_logprobs: Optional[List[float]] -
tokens: Optional[List[str]] -
top_logprobs: Optional[List[Dict[str, float]]]
-
-
text: str
-
-
created: intThe Unix timestamp (in seconds) of when the completion was created.
-
model: strThe model used for completion.
-
object: Literal["text_completion"]The object type, which is always "text_completion"
"text_completion"
-
system_fingerprint: Optional[str]This fingerprint represents the backend configuration that the model runs with.
Can be used in conjunction with the
seedrequest parameter to understand when backend changes have been made that might impact determinism. -
usage: Optional[CompletionUsage]Usage statistics for the completion request.
-
completion_tokens: intNumber of tokens in the generated completion.
-
prompt_tokens: intNumber of tokens in the prompt.
-
total_tokens: intTotal number of tokens used in the request (prompt + completion).
-
completion_tokens_details: Optional[CompletionTokensDetails]Breakdown of tokens used in a completion.
-
accepted_prediction_tokens: Optional[int]When using Predicted Outputs, the number of tokens in the prediction that appeared in the completion.
-
audio_tokens: Optional[int]Audio input tokens generated by the model.
-
reasoning_tokens: Optional[int]Tokens generated by the model for reasoning.
-
rejected_prediction_tokens: Optional[int]When using Predicted Outputs, the number of tokens in the prediction that did not appear in the completion. However, like reasoning tokens, these tokens are still counted in the total completion tokens for purposes of billing, output, and context window limits.
-
-
prompt_tokens_details: Optional[PromptTokensDetails]Breakdown of tokens used in the prompt.
-
audio_tokens: Optional[int]Audio input tokens present in the prompt.
-
cached_tokens: Optional[int]Cached tokens present in the prompt.
-
-
-
Example
import os
from openai import OpenAI
client = OpenAI(
api_key=os.environ.get("OPENAI_API_KEY"), # This is the default and can be omitted
)
for completion in client.completions.create(
model="gpt-3.5-turbo-instruct",
prompt="This is a test.",
):
print(completion)
Response
{
"id": "id",
"choices": [
{
"finish_reason": "stop",
"index": 0,
"logprobs": {
"text_offset": [
0
],
"token_logprobs": [
0
],
"tokens": [
"string"
],
"top_logprobs": [
{
"foo": 0
}
]
},
"text": "text"
}
],
"created": 0,
"model": "model",
"object": "text_completion",
"system_fingerprint": "system_fingerprint",
"usage": {
"completion_tokens": 0,
"prompt_tokens": 0,
"total_tokens": 0,
"completion_tokens_details": {
"accepted_prediction_tokens": 0,
"audio_tokens": 0,
"reasoning_tokens": 0,
"rejected_prediction_tokens": 0
},
"prompt_tokens_details": {
"audio_tokens": 0,
"cached_tokens": 0
}
}
}
No streaming
from openai import OpenAI
client = OpenAI()
client.completions.create(
model="VAR_completion_model_id",
prompt="Say this is a test",
max_tokens=7,
temperature=0
)
Response
{
"id": "cmpl-uqkvlQyYK7bGYrRHQ0eXlWi7",
"object": "text_completion",
"created": 1589478378,
"model": "VAR_completion_model_id",
"system_fingerprint": "fp_44709d6fcb",
"choices": [
{
"text": "\n\nThis is indeed a test",
"index": 0,
"logprobs": null,
"finish_reason": "length"
}
],
"usage": {
"prompt_tokens": 5,
"completion_tokens": 7,
"total_tokens": 12
}
}
Streaming
from openai import OpenAI
client = OpenAI()
for chunk in client.completions.create(
model="VAR_completion_model_id",
prompt="Say this is a test",
max_tokens=7,
temperature=0,
stream=True
):
print(chunk.choices[0].text)
Response
{
"id": "cmpl-7iA7iJjj8V2zOkCGvWF2hAkDWBQZe",
"object": "text_completion",
"created": 1690759702,
"choices": [
{
"text": "This",
"index": 0,
"logprobs": null,
"finish_reason": null
}
],
"model": "gpt-3.5-turbo-instruct"
"system_fingerprint": "fp_44709d6fcb",
}